function newm = zero2neighbour(m, update_at)
%ZERO2NEIGHBOUR(mat, update_at) - Replace zero values with neighbouring
%                                 non-zero values
%
% Each zero element in the matrix mat where update_at ist true is
% replaced by a neighbouring non-zero value. If there is none, the
% element stays zero. If there are different, the element is set to the
% maximal value of uint32, called nan here.
%
% Arguments:
%   mat - gpuArray of type uint32
%   update_at - gpuArray of type boolean, determining where to change
%       the given field
% Returns:
%   mat - updated field
    
    % read size and create fields of indices
    [Nx, Ny, Nz] = size(m);
    
    newm = m;
    newm(2:Nx,1:Ny,1:Nz) = arrayfun(@kernel, newm(2:Nx,1:Ny,1:Nz), ...
                                             m(1:Nx-1,1:Ny,1:Nz), ...
                                             update_at(2:Nx,1:Ny,1:Nz));
    newm(1:Nx-1,1:Ny,1:Nz) = arrayfun(@kernel, newm(1:Nx-1,1:Ny,1:Nz), ...
                                               m(2:Nx,1:Ny,1:Nz), ...
                                               update_at(1:Nx-1,1:Ny,1:Nz));
    newm(1:Nx,2:Ny,1:Nz) = arrayfun(@kernel, newm(1:Nx,2:Ny,1:Nz), ...
                                             m(1:Nx,1:Ny-1,1:Nz), ...
                                             update_at(1:Nx,2:Ny,1:Nz));
    newm(1:Nx,1:Ny-1,1:Nz) = arrayfun(@kernel, newm(1:Nx,1:Ny-1,1:Nz), ...
                                               m(1:Nx,2:Ny,1:Nz), ...
                                               update_at(1:Nx,1:Ny-1,1:Nz));
    newm(1:Nx,1:Ny,2:Nz) = arrayfun(@kernel, newm(1:Nx,1:Ny,2:Nz), ...
                                             m(1:Nx,1:Ny,1:Nz-1), ...
                                             update_at(1:Nx,1:Ny,2:Nz));
    newm(1:Nx,1:Ny,1:Nz-1) = arrayfun(@kernel, newm(1:Nx,1:Ny,1:Nz-1), ...
                                               m(1:Nx,1:Ny,2:Nz), ...
                                               update_at(1:Nx,1:Ny,1:Nz-1));
end

function x = kernel(r, n, d)
    % Element-wise comparison function used as a stencil kernel. Compare
    % the value at a point, r, with a neighbouring one, n. Only change when
    % d is true.
    % If n is zero or nan, return r unchaged. Otherwise, return the common
    % value if r and n are equal and nan if they differ.
    % 
    % r\n | 0   x   y  nan
    % --`------------------     n on top (in the columns)
    %  0  | 0   x   y   0       r on the left (in thie lines)
    %  x  | X   x  nan  x
    %  y  | y  nan  y   y
    % nan |nan nan nan nan

    % The possibilities are tested indepentend and put together by bitwise
    % or. If n is zero or nan, the fourth line gives r. Otherwise, the
    % fifth line gives n if it is equal to r or r is zero (seventh line)
    % and nan if they differ (eighth line).
    % If their case is not fulfilled, the lines give zero.
    % The last two lines set all to zero if d was not true and give just r.
    uintmax = bitcmp(uint32(0));
    x = bitor( ...
          uint32( ...
            bitor( ...
              uint32( or(n==0,n==uintmax)) * r, ...
              uint32(~or(n==0,n==uintmax)) * ...
                bitor( ...
                  uint32( or(n==r,r==0)) * n, ...
                  uint32(~or(n==r,r==0)) * uintmax ...
                ) ...
            ) ...
          ) * uint32(d), ...
          r * uint32(~d) ...
        );
end
